// Popovers and hints

// Fix popovers in math equations
function addHints() {
  // console.log('Called...')

  $('.mathpopup').each(function (index) {
    var anchor = $(this).parent();
    var href = anchor.attr('href') // this contains the hint!

    if (href) {
      // dump when debugging...
      // console.log('Found one!')
      // console.log(href);

      anchor.removeAttr('href')
      anchor.addClass('fix-popover')
      anchor.attr('tabindex', '0')
      anchor.attr('role', 'button')
      anchor.attr('data-bs-trigger', 'focus')
      anchor.attr('data-bs-container', 'body')
      anchor.attr('data-bs-toggle', 'popover')
      anchor.attr('data-bs-html', 'true')
      anchor.attr('data-bs-placement', 'top')
      anchor.attr('data-bs-content', href)
    }
  });

  $('.fix-popover').each(function () {
    new bootstrap.Popover($(this));
    $(this).on('shown.bs.popover', function () {
      MathJax.typeset();
    });
  });

  $('.fix-popover').removeClass('fix-popover');
  $('.mathpopup').removeClass('mathpopup');
}


// Bootstrap tooltips
//
// see https://getbootstrap.com/docs/5.1/components/tooltips/#example-enable-tooltips-everywhere

var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
  return new bootstrap.Tooltip(tooltipTriggerEl)
})

// AnchorJS

anchors.options.placement = 'right';
anchors.add('.anchored');

// Popovers
//
// see https://getbootstrap.com/docs/5.1/components/popovers/#example-enable-popovers-everywhere

var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
  return new bootstrap.Popover(popoverTriggerEl, {
    html: true,
    sanitize: false,
    container: 'body',
    trigger: 'focus',
    content: function () {
      var content = $(popoverTriggerEl).attr("data-content-id");
      return $(content).html();
    }
  })
})

// Typeset possible math content in popovers

$('[data-bs-toggle="popover"]').on('shown.bs.popover', function () {
  MathJax.typeset();
});

// Settings
var settings = JSON.parse(localStorage.getItem('settings')) || {
  currentTheme: 'light',
  systemTheme: true,
}

window.addEventListener('storage', function (event) {
  if (event.key === 'settings') {
    settings = JSON.parse(localStorage.getItem('settings'))
    applySettings()
  }
})

document.getElementById('settings-modal').addEventListener('show.bs.modal', function () {
  document.getElementById('settings-switch-system-theme').checked = settings.systemTheme
})

document.getElementById('settings-save').addEventListener('click', function () {
  settings = {
    currentTheme: settings.currentTheme,
    systemTheme: document.getElementById('settings-switch-system-theme').checked,
  }
  if (settings.systemTheme) {
    settings.currentTheme = isSystemDark() ? 'dark' : 'light'
  }
  saveSettings()
  applySettings()
})

document.getElementById('theme-switch-link').addEventListener('click', function () {
  if (settings.currentTheme === 'light') {
    settings.currentTheme = 'dark'
  } else {
    settings.currentTheme = 'light'
  }
  settings.systemTheme = false
  applyThemeFade(settings.currentTheme)
  saveSettings()
})

function applySettings() {
  if (settings.currentTheme === 'light') {
    switchToLight()
  } else {
    switchToDark()
  }
}

function saveSettings() {
  localStorage.setItem('settings', JSON.stringify(settings))
}

// Theme switching
function isSystemDark() {
  return window.matchMedia('(prefers-color-scheme: dark)').matches
}

if (settings.systemTheme) {
  settings.currentTheme = isSystemDark() ? 'dark' : 'light'
}

window.matchMedia('(prefers-color-scheme: dark)').addEventListener('change', function (event) {
  if (settings.systemTheme) {
    settings.currentTheme = event.matches ? 'dark' : 'light'
    saveSettings()
    applySettings()
  }
})

pygments_themes = {
  "light": "css/highlight.css",
  "dark": "css/highlight-dark.css"
}
pygments_theme_link = $('#pygments-theme-link')

function switchToLight() {
  document.documentElement.setAttribute('data-bs-theme', 'light')
  pygments_theme_link.attr('href', pygments_themes['light'])
  $('img.woowoo-image, img.woowoo-tikz, span.mjx-mstyle').removeClass('fix-dark')
  $('#theme-switch-icon').removeClass('fa-sun')
  $('#theme-switch-icon').addClass('fa-moon')
}

function switchToDark() {
  $('img.woowoo-image, img.woowoo-tikz, span.mjx-mstyle').addClass('fix-dark')
  $('#theme-switch-icon').removeClass('fa-moon')
  $('#theme-switch-icon').addClass('fa-sun')
  document.documentElement.setAttribute('data-bs-theme', 'dark')
  pygments_theme_link.attr('href', pygments_themes['dark'])
  $('img.woowoo-image, img.woowoo-tikz, span.mjx-mstyle').addClass('fix-dark')
  $('#theme-switch-icon').removeClass('fa-moon')
  $('#theme-switch-icon').addClass('fa-sun')
}

function applyThemeFade(theme) {
  pygments_theme_link = $('#pygments-theme-link')

  if (theme === 'light') {
    $("html").fadeOut(1000, function () {
      // console.log('Going light...')
      document.documentElement.setAttribute('data-bs-theme', 'light')
      pygments_theme_link.attr('href', pygments_themes['light'])
      $('img.woowoo-image, img.woowoo-tikz, mjx-mstyle').removeClass('fix-dark')
      $('#theme-switch-icon').removeClass('fa-sun')
      $('#theme-switch-icon').addClass('fa-moon')
      $("html").fadeIn(1000)
    });
  } else {
    $("html").fadeOut(1000, function () {
      // console.log('Going dark...')
      document.documentElement.setAttribute('data-bs-theme', 'dark')
      pygments_theme_link.attr('href', pygments_themes['dark'])
      $('img.woowoo-image, img.woowoo-tikz, mjx-mstyle').addClass('fix-dark')
      $('#theme-switch-icon').removeClass('fa-moon')
      $('#theme-switch-icon').addClass('fa-sun')
      $("html").fadeIn(1000)
    });
  }
};

// render pseudocode; moved to _head, run once MathJax is ready!
// $('pre.pseudocode').each( function (index) {
//   pseudocode.renderElement($(this)[0], { lineNumber: true });
// });

saveSettings()
applySettings()
